/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ACT_ACCEPT = 258,
     ACT_REJECT = 259,
     ACT_TEMPFAIL = 260,
     ACT_CONTINUE = 261,
     ACT_DISCARD = 262,
     ADD = 263,
     REPLACE = 264,
     DELETE = 265,
     IF = 266,
     FI = 267,
     ELSE = 268,
     ELIF = 269,
     ON = 270,
     HOST = 271,
     FOR = 272,
     FROM = 273,
     AS = 274,
     DO = 275,
     DONE = 276,
     POLL = 277,
     MATCHES = 278,
     FNMATCHES = 279,
     LISTENS = 280,
     WHEN = 281,
     HOSTNAME = 282,
     RELAYED = 283,
     RATE = 284,
     NEXT = 285,
     STRING = 286,
     CODE = 287,
     XCODE = 288,
     SYMBOL = 289,
     OR = 290,
     AND = 291,
     EQ = 292,
     NE = 293,
     NOT = 294
   };
#endif
#define ACT_ACCEPT 258
#define ACT_REJECT 259
#define ACT_TEMPFAIL 260
#define ACT_CONTINUE 261
#define ACT_DISCARD 262
#define ADD 263
#define REPLACE 264
#define DELETE 265
#define IF 266
#define FI 267
#define ELSE 268
#define ELIF 269
#define ON 270
#define HOST 271
#define FOR 272
#define FROM 273
#define AS 274
#define DO 275
#define DONE 276
#define POLL 277
#define MATCHES 278
#define FNMATCHES 279
#define LISTENS 280
#define WHEN 281
#define HOSTNAME 282
#define RELAYED 283
#define RATE 284
#define NEXT 285
#define STRING 286
#define CODE 287
#define XCODE 288
#define SYMBOL 289
#define OR 290
#define AND 291
#define EQ 292
#define NE 293
#define NOT 294




/* Copy the first part of user declarations.  */
#line 1 "gram.y"

/* This file is part of mailfrom filter.
   Copyright (C) 2005, 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <fnmatch.h>
#include <setjmp.h>
#include <netdb.h>
#include "mailfrom.h"

NODE *alloc_node(enum node_type type, const struct locus *locus);
int string_to_stat(char *, mf_status *);
void set_poll_arg(struct poll_node *poll, int kw, NODE *var);
static int time_multiplier(const char *, unsigned *, unsigned *);
 
static NODE *root_node;
static int regex_flags; /* Should default to REG_NOSUB ? */
 


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 39 "gram.y"
typedef union YYSTYPE {
	char *string;
	struct {
		NODE *head;
 		NODE *tail;
	} stmtlist;
	NODE *node;
	struct return_node ret;
	struct poll_node poll;
	struct {
		struct poll_action *head, *tail;
	} actionlist;
	struct locus locus;
	struct {
		int kw;
		NODE *var;
	} arg;
	double number;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 211 "gram.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 223 "gram.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  39
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   142

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  44
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  24
/* YYNRULES -- Number of rules. */
#define YYNRULES  64
/* YYNRULES -- Number of states. */
#define YYNSTATES  109

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   294

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      40,    41,     2,     2,     2,     2,     2,    42,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    43,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    12,    14,    17,    20,
      23,    25,    27,    29,    33,    37,    40,    41,    43,    45,
      48,    52,    55,    57,    59,    65,    66,    71,    74,    78,
      82,    86,    90,    94,    98,   101,   105,   108,   113,   116,
     117,   120,   123,   125,   128,   131,   132,   134,   136,   142,
     145,   147,   150,   152,   155,   158,   161,   164,   166,   169,
     174,   176,   180,   182,   184
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      45,     0,    -1,    46,    -1,    47,    -1,    46,    47,    -1,
      51,    -1,    48,    -1,     3,    49,    -1,     4,    49,    -1,
       5,    49,    -1,     6,    -1,     7,    -1,    30,    -1,     8,
      31,    31,    -1,     9,    31,    31,    -1,    10,    31,    -1,
      -1,    50,    -1,    32,    -1,    32,    33,    -1,    32,    33,
      31,    -1,    32,    31,    -1,    52,    -1,    60,    -1,    11,
      54,    46,    53,    12,    -1,    -1,    14,    54,    46,    53,
      -1,    13,    46,    -1,    67,    37,    67,    -1,    67,    38,
      67,    -1,    67,    23,    67,    -1,    67,    24,    67,    -1,
      54,    35,    54,    -1,    54,    36,    54,    -1,    39,    54,
      -1,    40,    54,    41,    -1,    28,    67,    -1,    29,    67,
      59,    55,    -1,    25,    67,    -1,    -1,    42,    59,    -1,
      42,    56,    -1,    57,    -1,    56,    57,    -1,    58,    31,
      -1,    -1,    59,    -1,    32,    -1,    15,    61,    20,    64,
      21,    -1,    22,    62,    -1,    63,    -1,    62,    63,    -1,
      67,    -1,    17,    67,    -1,    16,    67,    -1,    19,    67,
      -1,    18,    67,    -1,    65,    -1,    64,    65,    -1,    26,
      66,    43,    46,    -1,    31,    -1,    66,    35,    31,    -1,
      31,    -1,    34,    -1,    27,    67,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    83,    83,    89,    94,   102,   103,   106,   112,   118,
     124,   129,   134,   138,   145,   152,   161,   164,   167,   173,
     179,   185,   193,   194,   197,   207,   210,   217,   223,   230,
     237,   262,   269,   276,   283,   289,   293,   298,   304,   312,
     315,   319,   325,   326,   332,   344,   347,   350,   362,   370,
     376,   381,   388,   393,   398,   403,   408,   416,   417,   425,
     436,   454,   476,   481,   486
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACT_ACCEPT", "ACT_REJECT", "ACT_TEMPFAIL", 
  "ACT_CONTINUE", "ACT_DISCARD", "ADD", "REPLACE", "DELETE", "IF", "FI", 
  "ELSE", "ELIF", "ON", "HOST", "FOR", "FROM", "AS", "DO", "DONE", "POLL", 
  "MATCHES", "FNMATCHES", "LISTENS", "WHEN", "HOSTNAME", "RELAYED", 
  "RATE", "NEXT", "STRING", "CODE", "XCODE", "SYMBOL", "OR", "AND", "EQ", 
  "NE", "NOT", "'('", "')'", "'/'", "':'", "$accept", "input", "stmtlist", 
  "stmt", "action", "maybe_triplet", "triplet", "condition", "if_cond", 
  "else_cond", "cond", "divisor", "timespec", "time", "factor", "number", 
  "on_cond", "pollstmt", "arglist", "pollarg", "branches", "branch", 
  "values", "var", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
      40,    41,    47,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    44,    45,    46,    46,    47,    47,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    49,    49,    50,    50,
      50,    50,    51,    51,    52,    53,    53,    53,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    55,
      55,    55,    56,    56,    57,    58,    58,    59,    60,    61,
      62,    62,    63,    63,    63,    63,    63,    64,    64,    65,
      66,    66,    67,    67,    67
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     2,     1,     1,     2,     2,     2,
       1,     1,     1,     3,     3,     2,     0,     1,     1,     2,
       3,     2,     1,     1,     5,     0,     4,     2,     3,     3,
       3,     3,     3,     3,     2,     3,     2,     4,     2,     0,
       2,     2,     1,     2,     2,     0,     1,     1,     5,     2,
       1,     2,     1,     2,     2,     2,     2,     1,     2,     4,
       1,     3,     1,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,    16,    16,    16,    10,    11,     0,     0,     0,     0,
       0,    12,     0,     2,     3,     6,     5,    22,    23,    18,
       7,    17,     8,     9,     0,     0,    15,     0,     0,     0,
       0,    62,    63,     0,     0,     0,     0,     0,     0,     1,
       4,    21,    19,    13,    14,    38,    64,    36,     0,    34,
       0,     0,     0,    25,     0,     0,     0,     0,     0,     0,
       0,     0,    49,    50,    52,     0,    20,    47,    39,    35,
      32,    33,     0,     0,     0,    30,    31,    28,    29,    54,
      53,    56,    55,    51,     0,     0,    57,    45,    37,    27,
       0,    24,    60,     0,    48,    58,    41,    42,     0,    40,
      25,     0,     0,    43,    46,    44,    26,    61,    59
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,    12,    13,    14,    15,    20,    21,    16,    17,    74,
      35,    88,    96,    97,    98,    68,    18,    38,    62,    63,
      85,    86,    93,    36
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -84
static const yysigned_char yypact[] =
{
      93,   -25,   -25,   -25,   -84,   -84,     5,     6,    10,   102,
      -7,   -84,    55,    93,   -84,   -84,   -84,   -84,   -84,    32,
     -84,   -84,   -84,   -84,    31,    35,   -84,    30,    30,    30,
      30,   -84,   -84,   102,   102,    24,   -15,    94,    47,   -84,
     -84,   -84,    38,   -84,   -84,   -84,   -84,   -84,    39,   -84,
      17,   102,   102,    75,    30,    30,    30,    30,    30,    30,
      30,    30,    94,   -84,   -84,    44,   -84,   -84,    33,   -84,
      36,   -84,    93,   102,    61,   -84,   -84,   -84,   -84,   -84,
     -84,   -84,   -84,   -84,    43,   -16,   -84,    39,   -84,    93,
      24,   -84,   -84,   -29,   -84,   -84,   -20,   -84,    46,    60,
      75,    62,    93,   -84,   -84,   -84,   -84,   -84,    93
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -84,   -84,   -34,   -13,   -84,    22,   -84,   -84,   -84,    -8,
     -31,   -84,   -84,    -2,   -84,   -83,   -84,   -84,   -84,    45,
     -84,    21,   -84,   -11
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -47
static const yysigned_char yytable[] =
{
      40,    53,    49,    50,    99,    94,   101,    19,    54,    55,
      84,   -45,    67,   104,   102,    37,    45,    46,    47,    48,
      70,    71,    56,    57,    22,    23,    64,     1,     2,     3,
       4,     5,     6,     7,     8,     9,    24,    25,    89,    10,
      40,    26,    90,    75,    76,    77,    78,    79,    80,    81,
      82,    64,    51,    52,    11,    39,   100,    28,    69,    51,
      52,    31,    43,    41,    32,    42,    44,    65,   108,    66,
      84,    67,    52,    91,    92,    87,    40,   105,     1,     2,
       3,     4,     5,     6,     7,     8,     9,    40,    72,    73,
      10,   -46,   106,   107,   103,    40,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    11,    95,    83,    10,     0,
      58,    59,    60,    61,     0,     0,     0,     0,     0,     0,
       0,    28,     0,    11,     0,    31,     0,    27,    32,    28,
      29,    30,     0,    31,     0,     0,    32,     0,     0,     0,
       0,    33,    34
};

static const yysigned_char yycheck[] =
{
      13,    35,    33,    34,    87,    21,    35,    32,    23,    24,
      26,    31,    32,    96,    43,    22,    27,    28,    29,    30,
      51,    52,    37,    38,     2,     3,    37,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    31,    31,    72,    15,
      53,    31,    73,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    35,    36,    30,     0,    90,    27,    41,    35,
      36,    31,    31,    31,    34,    33,    31,    20,   102,    31,
      26,    32,    36,    12,    31,    42,    89,    31,     3,     4,
       5,     6,     7,     8,     9,    10,    11,   100,    13,    14,
      15,    31,   100,    31,    96,   108,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    30,    85,    62,    15,    -1,
      16,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    27,    -1,    30,    -1,    31,    -1,    25,    34,    27,
      28,    29,    -1,    31,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    39,    40
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      15,    30,    45,    46,    47,    48,    51,    52,    60,    32,
      49,    50,    49,    49,    31,    31,    31,    25,    27,    28,
      29,    31,    34,    39,    40,    54,    67,    22,    61,     0,
      47,    31,    33,    31,    31,    67,    67,    67,    67,    54,
      54,    35,    36,    46,    23,    24,    37,    38,    16,    17,
      18,    19,    62,    63,    67,    20,    31,    32,    59,    41,
      54,    54,    13,    14,    53,    67,    67,    67,    67,    67,
      67,    67,    67,    63,    26,    64,    65,    42,    55,    46,
      54,    12,    31,    66,    21,    65,    56,    57,    58,    59,
      46,    35,    43,    57,    59,    31,    53,    31,    46
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 84 "gram.y"
    {
		     root_node = yyvsp[0].stmtlist.head;
	     }
    break;

  case 3:
#line 90 "gram.y"
    {
		     yyvsp[0].node->next = NULL;
		     yyval.stmtlist.head = yyval.stmtlist.tail = yyvsp[0].node;
	     }
    break;

  case 4:
#line 95 "gram.y"
    {
		     yyvsp[-1].stmtlist.tail->next = yyvsp[0].node;
		     yyvsp[-1].stmtlist.tail = yyvsp[0].node;
		     yyval.stmtlist = yyvsp[-1].stmtlist;
	     }
    break;

  case 7:
#line 107 "gram.y"
    {
		     yyval.node = alloc_node(node_type_return, &yyvsp[-1].locus);
		     yyval.node->v.ret = yyvsp[0].ret;
		     yyval.node->v.ret.stat = SMFIS_ACCEPT;
	     }
    break;

  case 8:
#line 113 "gram.y"
    {
		     yyval.node = alloc_node(node_type_return, &yyvsp[-1].locus);
		     yyval.node->v.ret = yyvsp[0].ret;
		     yyval.node->v.ret.stat = SMFIS_REJECT;
	     }
    break;

  case 9:
#line 119 "gram.y"
    {
		     yyval.node = alloc_node(node_type_return, &yyvsp[-1].locus);
		     yyval.node->v.ret = yyvsp[0].ret;
		     yyval.node->v.ret.stat = SMFIS_TEMPFAIL;
	     }
    break;

  case 10:
#line 125 "gram.y"
    {
		     yyval.node = alloc_node(node_type_return, &yyvsp[0].locus);
		     yyval.node->v.ret.stat = SMFIS_CONTINUE;
	     }
    break;

  case 11:
#line 130 "gram.y"
    {
		     yyval.node = alloc_node(node_type_return, &yyvsp[0].locus);
		     yyval.node->v.ret.stat = SMFIS_DISCARD;
	     }
    break;

  case 12:
#line 135 "gram.y"
    {
		     yyval.node = alloc_node(node_type_next, &yyvsp[0].locus);
	     }
    break;

  case 13:
#line 139 "gram.y"
    {
		     yyval.node = alloc_node(node_type_header, &yyvsp[-2].locus);
		     yyval.node->v.hdr.opcode = header_add;
		     yyval.node->v.hdr.name = yyvsp[-1].string;
		     yyval.node->v.hdr.value = yyvsp[0].string;
	     }
    break;

  case 14:
#line 146 "gram.y"
    {
		     yyval.node = alloc_node(node_type_header, &yyvsp[-2].locus);
		     yyval.node->v.hdr.opcode = header_replace;
		     yyval.node->v.hdr.name = yyvsp[-1].string;
		     yyval.node->v.hdr.value = yyvsp[0].string;
	     }
    break;

  case 15:
#line 153 "gram.y"
    {
		     yyval.node = alloc_node(node_type_header, &yyvsp[-1].locus);
		     yyval.node->v.hdr.opcode = header_delete;
		     yyval.node->v.hdr.name = yyvsp[0].string;
	     }
    break;

  case 16:
#line 161 "gram.y"
    {
		     memset(&yyval.ret, 0, sizeof yyval.ret);
	     }
    break;

  case 18:
#line 168 "gram.y"
    {
		     yyval.ret.code = yyvsp[0].string;
		     yyval.ret.xcode = NULL;
		     yyval.ret.message = NULL;
	     }
    break;

  case 19:
#line 174 "gram.y"
    {
		     yyval.ret.code = yyvsp[-1].string;
		     yyval.ret.xcode = yyvsp[0].string;
		     yyval.ret.message = NULL;
	     }
    break;

  case 20:
#line 180 "gram.y"
    {
		     yyval.ret.code = yyvsp[-2].string;
		     yyval.ret.xcode = yyvsp[-1].string;
		     yyval.ret.message = yyvsp[0].string;
	     }
    break;

  case 21:
#line 186 "gram.y"
    {
		     yyval.ret.code = yyvsp[-1].string;
		     yyval.ret.xcode = NULL;
		     yyval.ret.message = yyvsp[0].string;
	     }
    break;

  case 24:
#line 198 "gram.y"
    {
		     yyval.node = alloc_node(node_type_if, &yyvsp[-4].locus);
		     yyval.node->v.cond.cond = yyvsp[-3].node;
		     yyval.node->v.cond.if_true = yyvsp[-2].stmtlist.head;
		     yyval.node->v.cond.if_false = yyvsp[-1].node;
	     }
    break;

  case 25:
#line 207 "gram.y"
    {
		     yyval.node = NULL;
	     }
    break;

  case 26:
#line 211 "gram.y"
    {
		     yyval.node = alloc_node(node_type_if, &yyvsp[-3].locus);
		     yyval.node->v.cond.cond = yyvsp[-2].node;
		     yyval.node->v.cond.if_true = yyvsp[-1].stmtlist.head;
		     yyval.node->v.cond.if_false = yyvsp[0].node;
	     }
    break;

  case 27:
#line 218 "gram.y"
    {
		     yyval.node = yyvsp[0].stmtlist.head;
	     }
    break;

  case 28:
#line 224 "gram.y"
    {
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     yyval.node->v.bin.opcode = bin_eq;
		     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
		     yyval.node->v.bin.arg[1] = yyvsp[0].node;
	     }
    break;

  case 29:
#line 231 "gram.y"
    {
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     yyval.node->v.bin.opcode = bin_ne;
		     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
		     yyval.node->v.bin.arg[1] = yyvsp[0].node;
	     }
    break;

  case 30:
#line 238 "gram.y"
    {
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     if (yyvsp[0].node->type == node_type_string) {
			     int rc;
			     
			     yyval.node->v.re.opcode = bin_regex;
			     yyval.node->v.re.arg = yyvsp[-2].node;
			     rc = regcomp(&yyval.node->v.re.regex, yyvsp[0].node->v.string,
					  regex_flags);
			     if (rc) {
				     char errbuf[512];
				     regerror(rc, &yyval.node->v.re.regex, errbuf,
					      sizeof(errbuf));
				     parse_error("Cannot compile regex: %s",
						 errbuf);
				     YYERROR;

			     }
		     } else {
			     yyval.node->v.bin.opcode = bin_match;
			     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
			     yyval.node->v.bin.arg[1] = yyvsp[0].node;
		     }
	     }
    break;

  case 31:
#line 263 "gram.y"
    {
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     yyval.node->v.bin.opcode = bin_fnmatch;
		     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
		     yyval.node->v.bin.arg[1] = yyvsp[0].node;
	     }
    break;

  case 32:
#line 270 "gram.y"
    {
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     yyval.node->v.bin.opcode = bin_or;
		     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
		     yyval.node->v.bin.arg[1] = yyvsp[0].node;
	     }
    break;

  case 33:
#line 277 "gram.y"
    {
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     yyval.node->v.bin.opcode = bin_and;
		     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
		     yyval.node->v.bin.arg[1] = yyvsp[0].node;
	     }
    break;

  case 34:
#line 284 "gram.y"
    {
		     yyval.node = alloc_node(node_type_un, &yyvsp[-1].locus);
		     yyval.node->v.un.opcode = unary_not;
		     yyval.node->v.un.arg = yyvsp[0].node;
	     }
    break;

  case 35:
#line 290 "gram.y"
    {
		     yyval.node = yyvsp[-1].node;
	     }
    break;

  case 36:
#line 294 "gram.y"
    {
		     yyval.node = alloc_node(node_type_relayed_domain, &yyvsp[-1].locus);
		     yyval.node->v.node = yyvsp[0].node;
	     }
    break;

  case 37:
#line 299 "gram.y"
    {
		     yyval.node = alloc_node(node_type_rate, get_locus());
		     yyval.node->v.rate.email = yyvsp[-2].node;
		     yyval.node->v.rate.limit = yyvsp[-1].number / yyvsp[0].number;
	     }
    break;

  case 38:
#line 305 "gram.y"
    {
		     yyval.node = alloc_node(node_type_listens, &yyvsp[-1].locus);
		     yyval.node->v.node = yyvsp[0].node;
	     }
    break;

  case 39:
#line 312 "gram.y"
    {
		     yyval.number = 1;
	     }
    break;

  case 40:
#line 316 "gram.y"
    {
		     yyval.number = yyvsp[0].number;
	     }
    break;

  case 41:
#line 320 "gram.y"
    {
		     yyval.number = yyvsp[0].number;
	     }
    break;

  case 43:
#line 327 "gram.y"
    {
		     yyval.number = yyvsp[-1].number + yyvsp[0].number;
	     }
    break;

  case 44:
#line 333 "gram.y"
    {
		     unsigned m;
		     if (time_multiplier(yyvsp[0].string, &m, NULL)) {
			     parse_error("Invalid time unit: %s", yyvsp[0].string);
			     YYERROR;
		     }
		     yyval.number = yyvsp[-1].number * m;
	     }
    break;

  case 45:
#line 344 "gram.y"
    {
		     yyval.number = 1;
	     }
    break;

  case 47:
#line 351 "gram.y"
    {
		     char *p;
		     yyval.number = strtod(yyvsp[0].string, &p);
		     if (*p) {
			     /* should not happen */
			     parse_error("Invalid number (near `%s')", p);
			     YYERROR;
		     }
	     }
    break;

  case 48:
#line 363 "gram.y"
    {
		     yyval.node = alloc_node(node_type_poll, &yyvsp[-4].locus);
		     yyval.node->v.poll = yyvsp[-3].poll;
		     yyval.node->v.poll.actions = yyvsp[-1].actionlist.head;
	     }
    break;

  case 49:
#line 371 "gram.y"
    {
		     yyval.poll = yyvsp[0].poll;
	     }
    break;

  case 50:
#line 377 "gram.y"
    {
		     memset(&yyval.poll, 0, sizeof yyval.poll);
		     set_poll_arg(&yyval.poll, yyvsp[0].arg.kw, yyvsp[0].arg.var);
	     }
    break;

  case 51:
#line 382 "gram.y"
    {
		     set_poll_arg(&yyvsp[-1].poll, yyvsp[0].arg.kw, yyvsp[0].arg.var);
		     yyval.poll = yyvsp[-1].poll;
	     }
    break;

  case 52:
#line 389 "gram.y"
    {
		     yyval.arg.kw = FOR;
		     yyval.arg.var = yyvsp[0].node;
	     }
    break;

  case 53:
#line 394 "gram.y"
    {
		     yyval.arg.kw = FOR;
		     yyval.arg.var = yyvsp[0].node;
	     }
    break;

  case 54:
#line 399 "gram.y"
    {
		     yyval.arg.kw = HOST;
		     yyval.arg.var = yyvsp[0].node;
	     }
    break;

  case 55:
#line 404 "gram.y"
    {
		     yyval.arg.kw = AS;
		     yyval.arg.var = yyvsp[0].node;
	     }
    break;

  case 56:
#line 409 "gram.y"
    {
		     yyval.arg.kw = FROM;
		     yyval.arg.var = yyvsp[0].node;
	     }
    break;

  case 58:
#line 418 "gram.y"
    {
		     yyvsp[-1].actionlist.tail->next = yyvsp[0].actionlist.head;
		     yyvsp[-1].actionlist.tail = yyvsp[0].actionlist.tail;
		     yyval.actionlist = yyvsp[-1].actionlist;
	     }
    break;

  case 59:
#line 426 "gram.y"
    {
		     struct poll_action *act;
		     for (act = yyvsp[-2].actionlist.head; act; act = act->next) {
			     act->locus = yyvsp[-3].locus;
			     act->node = yyvsp[0].stmtlist.head;
		     }
		     yyval.actionlist = yyvsp[-2].actionlist;
	     }
    break;

  case 60:
#line 437 "gram.y"
    {
		     mf_status status;

		     if (string_to_stat(yyvsp[0].string, &status)) {
			     parse_error("Unknown return code: %s", yyvsp[0].string);
			     YYERROR;
		     } else {
			     struct poll_action *act = malloc(sizeof *act);
			     if (!act) {
				     parse_error("Not enough memory");
				     abort();
			     }
			     act->next = NULL;
			     act->status = status;
			     yyval.actionlist.head = yyval.actionlist.tail = act;
		     }
	     }
    break;

  case 61:
#line 455 "gram.y"
    {
		     mf_status status;

		     if (string_to_stat(yyvsp[0].string, &status)) {
			     parse_error("Unknown return code: %s", yyvsp[-2].actionlist);
			     YYERROR;
		     } else {
			     struct poll_action *act = malloc(sizeof *act);
			     if (!act) {
				     parse_error("Not enough memory");
				     abort();
			     }
			     act->next = NULL;
			     act->status = status;
			     yyvsp[-2].actionlist.tail->next = act;
			     yyvsp[-2].actionlist.tail = act;
			     yyval.actionlist = yyvsp[-2].actionlist;
		     }
	     }
    break;

  case 62:
#line 477 "gram.y"
    {
		     yyval.node = alloc_node(node_type_string, get_locus());
		     yyval.node->v.string = yyvsp[0].string;
	     }
    break;

  case 63:
#line 482 "gram.y"
    {
		     yyval.node = alloc_node(node_type_symbol, get_locus());
		     yyval.node->v.string = yyvsp[0].string;
	     }
    break;

  case 64:
#line 487 "gram.y"
    {
		     yyval.node = alloc_node(node_type_hostname, get_locus());
		     yyval.node->v.node = yyvsp[0].node;
	     }
    break;


    }

/* Line 991 of yacc.c.  */
#line 1723 "gram.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 493 "gram.y"


int
yyerror(char *s)
{
	parse_error("%s", s);
}


int
parse_config(char *name, int ydebug, int ldebug)
{
	yydebug = ydebug;
	if (source(name, ldebug))
		return -1;
	return yyparse();
}
	
NODE *
alloc_node(enum node_type type, const struct locus *locus)
{
	NODE *node = malloc(sizeof(*node));
	if (!node) {
		yyerror("Not enough memory");
		abort();
	}
	node->type = type;
	node->locus = *locus;
	node->next = NULL;
	return node;
}
	
int
string_to_stat(char *str, mf_status *status)
{
	if (strcmp(str, "success") == 0)
		*status = mf_success;
	else if (strcmp(str, "not_found") == 0)
		*status = mf_not_found;
	else if (strcmp(str, "failure") == 0)
		*status = mf_failure;
	else if (strcmp(str, "temp_failure") == 0)
		*status = mf_temp_failure;
	else
		return 1;
	return 0;
}


/* Print parse tree */

static void print_node_list(NODE *node, int indent);
static void print_node(NODE *node, int indent);
void print_stat(sfsistat stat);
static int dbg_setreply(void *data, char *code, char *xcode, char *message);
static void dbg_setheader(void *data, struct header_node *hdr);


static char *
mf_status_str(mf_status stat)
{
	switch (stat) {
	case mf_success:
		return "success";
	case mf_not_found:
		return "not_found";
	case mf_failure:
		return "failure";
	case mf_temp_failure:
		return "temp_failure";
	}
	return "UNKNOWN";
}

static void
print_level(int level)
{
	level *= 2;
	printf("%*.*s", level, level, "");
}


static void
print_poll(struct poll_node *poll, int level)
{
	struct poll_action *act;

	print_level(level);
	printf("POLL\n");
	print_level(level+1);
	printf("FOR:\n");
	print_node(poll->email, level+2);
	if (poll->client_addr) {
		print_level(level+1);
		printf("HOST:\n");
		print_node(poll->client_addr, level+2);
	}
	if (poll->mailfrom) {
		print_level(level+1);
		printf("MAIL FROM:\n");
		print_node(poll->mailfrom, level+2);
	}
	if (poll->ehlo) {
		print_level(level+1);
		printf("EHLO:\n");
		print_node(poll->ehlo, level+2);
	}
	
	for (act = poll->actions; act; act = act->next) {
		print_level(level+1);
		printf("when %s:\n", mf_status_str(act->status));
		print_node_list(act->node, level+2);
	}
}

static void
print_bin_op(enum bin_opcode opcode)
{
	char *p;
	switch (opcode) {
	case bin_and:
		p = "AND";
		break;
		
	case bin_or:
		p = "OR";
		break;
		
	case bin_eq:
		p = "EQ";
		break;
		
	case bin_ne:
		p = "NE";
		break;

	case bin_match:
		p = "MATCH";
		break;
		
	case bin_fnmatch:
		p = "FNMATCH";
		break;

	case bin_regex:
		p = "REGEX";
		break;
		
	default:
		p = "UNKNOWN_OP";
	}
	printf("%s", p);
}

static void
print_node(NODE *node, int level)
{
	switch (node->type) {
	case node_type_string:
		print_level(level);
		printf("CONSTANT: %s\n", node->v.string);
		break;
		
	case node_type_symbol:
		print_level(level);
		printf("SYMBOL: %s\n", node->v.string);
		break;
		
	case node_type_if:
		print_level(level);
		printf("COND: \n");
		print_node(node->v.cond.cond, level);
		print_level(level);
		printf("IFTRUE\n");
		print_node_list(node->v.cond.if_true, level+1);
		print_level(level);
		printf("IFFALSE\n");
		print_node_list(node->v.cond.if_false, level+1);
		break;
		
	case node_type_poll:
		print_poll(&node->v.poll, level);
		break;
		
	case node_type_bin:
		print_level(level);
		print_bin_op(node->v.bin.opcode);
		printf("\n");
		print_node(node->v.bin.arg[0], level+1);
		if (node->v.bin.opcode != bin_regex)
			print_node(node->v.bin.arg[1], level+1);
		else {
			print_level(level+1);
			printf("/* COMPILED REGEX */\n");
		}
		break;
		
	case node_type_un:
		print_level(level);
		printf("NOT ");
		print_node(node->v.un.arg, 0);
		break;

	case node_type_next:
		print_level(level);
		printf("next\n");
		break;
		
	case node_type_return:
		if (node->v.ret.code) {
			print_level(level);
			dbg_setreply(NULL, node->v.ret.code,
				     node->v.ret.xcode,
				     node->v.ret.message);
		}
		print_level(level);
		print_stat(node->v.ret.stat);
		printf("\n");
		break;
		
	case node_type_header:
		print_level(level);
		dbg_setheader(NULL, &node->v.hdr);
		break;

	case node_type_hostname:
		print_level(level);
		printf("HOSTNAME\n");
		print_node(node->v.node, level+1);
		break;

	case node_type_relayed_domain:
		print_level(level);
		printf("RELAYED\n");
		print_node(node->v.node, level+1);
		break;
		
	case node_type_rate:
		print_level(level);
		printf("RATE %g\n", node->v.rate.limit);
		print_node(node->v.rate.email, level+1);
		break;

	case node_type_listens:
		print_level(level);
		printf("LISTENS\n");
		print_node(node->v.node, level+1);
		break;
		
	default:
		abort();
	}		

}	

static void
print_node_list(NODE *node, int level)
{
	for (; node; node = node->next)
		print_node(node, level);
}

void
print_config()
{
	print_node_list(root_node, 0);
}



#define skip_ws(p) while (*(p) && isspace(*(p))) (p)++;
			  
static char *
getword(char **p, char **buf)
{
	int len;
	
	skip_ws(*p);
	if (!**p)
		return NULL;
	for (len = 0; (*p)[len] && !isspace((*p)[len]); len++)
		;
	*buf = malloc(len+1);
	if (*buf) {
		memcpy(*buf, *p, len);
		(*buf)[len] = 0;
	}
	*p += len;
	return *buf;
}

enum regex_mode { regex_enable, regex_disable, regex_set };

static void
pragma_regex(char *text)
{
	char *p, *buf;
	int bit;
	enum regex_mode mode = regex_set;
	
	while (p = getword(&text, &buf)) {
		switch (p[0]) {
		case '+':
			mode = regex_enable;
			p++;
			break;

		case '-':
			mode = regex_disable;
			p++;
			break;

		case '=':
			mode = regex_set;
			p++;
			break;
		}

		if (strcmp (p, "extended") == 0)
			bit = REG_EXTENDED;
		else if (strcmp (p, "icase") == 0)
			bit = REG_ICASE;
		else if (strcmp (p, "newline") == 0)
			bit = REG_NEWLINE;
		else {
			parse_error("Unknown regexp flag: %s", p);
			free(buf);
			return;
		}

		switch (mode) {
		case regex_disable:
			regex_flags &= ~bit;
			break;
		case regex_enable:
			regex_flags |= bit;
			break;
		case regex_set:
			regex_flags = bit;
			break;
		}
		free(buf);
	}
}

static void
pragma_option(char *text)
{
	char *name;
	char *value;
	char *p;
	int len;
	
	if (!getword(&text, &name)) {
		parse_error("Invalid pragma: expected option name");
		return;
	}
	if (!getword(&text, &value)) {
		parse_error("Invalid pragma: expected option value");
		free(name);
		return;
	}

	skip_ws(text);
	if (*text) {
		parse_error("Invalid pragma: junk after the arguments");
		/* Try to handle it anyway */
	}

	p = value;
	len = strlen(p);
	if ((*p == '"' || *p == '\'') && p[len-1] == *p) {
		p[len-1] = 0;
		p++;
	}
		
	if (set_option(name, p, 0)) {
		if (errno == ENOENT)
			parse_error("Unknown pragma option");
		else
			parse_error("Invalid pragma");
	}
	
	free(name);
	free(value);
}

void
parse_pragma(char *text)
{
	char *buf;

	while (*text != '#')
		text++;
	++text;
	skip_ws(text);
	text += 6; /* "pragma" */

	if (!getword(&text, &buf))
		parse_error("Empty pragma");
	else if (strcmp(buf, "regex") == 0)
		pragma_regex(text);
	else if (strcmp(buf, "option") == 0)
		pragma_option(text);
	else
		parse_error("Unknown pragma");
	free(buf);
}


/* Rudimentary dictionary support */
struct dict_entry {
	char *name;
	char *value;
};

static int
name_comp(const void *item, const void *data)
{
	const struct dict_entry *ent = item;
	const struct dict_entry *p = data;
	return strcmp(ent->name, p->name);
}

void
name_destroy(void *item)
{
	const struct dict_entry *ent = item;
	free(ent->name);
	free(ent->value);
}

void
dict_init(list_t *dict)
{
	list_create(dict);
	list_set_comparator(*dict, name_comp);
	list_set_destroy_item (*dict, name_destroy);
}

char *
dict_install(list_t dict, char *name, char *value)
{
	struct dict_entry ent, *p;

	ent.name = name;

	if (list_locate(dict, &ent, (void**)&p) == 0) {
		free(p->value);
		p->value = strdup(value);
	} else {
		p = malloc(sizeof(*p));
		if (!p)
			abort();
		p->name = strdup(name);
		p->value = strdup(value);
		list_append(dict, p);
	}
	return p->value;
}

void
dict_destroy(list_t *dict)
{
	list_destroy(dict);
}

char *
dict_getsym(void *data, char *str)
{
	struct dict_entry ent, *p;
	char *tmp = NULL;
	char *val = NULL;
	
	if (str[0] == '{') {
		int len = strlen(str);
		if (str[len-1] == '}') {
			tmp = malloc(len-1);
			if (!tmp)
				abort();
			memcpy(tmp, str+1, len-2);
			tmp[len-2] = 0;
			str = tmp;
		}
	}
	
	ent.name = str;
	if (list_locate(data, &ent, (void**)&p) == 0)
		val = p->value;
	free(tmp);
	return val;
}




/* Runtime support */

union value {
	int bool;
	char *string;
};

struct eval_environ {
	void *data;
	SMFICTX *ctx;
	char *(*getsym)(void *data, char *str);
	int (*setreply)(void *data, char *code, char *xcode, char *message);
	void (*setheader)(void *data, struct header_node *hdr);

	list_t dict;
	
	/* Exit information */
	sfsistat status;
	jmp_buf x;
};

void eval_node_list(NODE *node, struct eval_environ *env);
void eval_node(NODE *node, struct eval_environ *env, union value *val);

void
eval_poll(NODE *node, struct eval_environ *env)
{
	struct poll_node *poll = &node->v.poll;
	mf_status rc;
	struct poll_action *act;
	union value vemail, vaddr, vehlo, vmailfrom;

	eval_node(poll->email, env, &vemail);
	if (poll->ehlo)
		eval_node(poll->ehlo, env, &vehlo);
	else
		vehlo.string = smtp_domain;
	if (poll->mailfrom)
		eval_node(poll->mailfrom, env, &vmailfrom);
	else
		vmailfrom.string = postmaster_email;
	
	if (poll->client_addr) {
		union value vaddr;
		eval_node(poll->client_addr, env, &vaddr);
		trace("%s:%lu: STRICT POLL FOR %s HOST %s FROM %s AS <%s>",
		      node->locus.file, node->locus.line,
		      vemail.string, vaddr.string,
		      vehlo.string, vmailfrom.string);
		rc = method_strict(env->ctx, vemail.string, vaddr.string,
				   vehlo.string, vmailfrom.string);
	} else {
		trace("%s:%lu: STANDARD POLL FOR %s FROM %s AS <%s>",
		      node->locus.file, node->locus.line,
		      vemail.string, vehlo.string, vmailfrom.string);
		rc = method_standard(env->ctx, vemail.string,
				     vehlo.string, vmailfrom.string);
	}
	
	for (act = poll->actions; act; act = act->next) {
		if (act->status == rc)
			eval_node_list(act->node, env);
	}
}

void
eval_hostname(struct eval_environ *env, union value *val)
{
	char *s = dict_getsym(env->dict, val->string);
	if (!s) {
		char hbuf[NI_MAXHOST];
		if (resolve_ipstr(val->string, hbuf, sizeof(hbuf)) == 0) {
			s = dict_install(env->dict, val->string, hbuf);
		} else
			return; /* val is not changed */
	}
	val->string = s;
}

void
eval_rate(NODE *node, struct eval_environ *env,
	  union value *email, double limit, union value *res)
{
	char *p;
	double rate;

	if (get_rate(email->string, &rate) != mf_success) {
		mu_error("%s:%lu: runtime error: cannot get rate for %s",
			 node->locus.file, node->locus.line, email->string);
		env->status = SMFIS_TEMPFAIL;
		longjmp(env->x, 1);
	}

	res->bool = rate > limit;
}

void
eval_node(NODE *node, struct eval_environ *env, union value *val)
{
	union value vtmp;

	switch (node->type) {
	case node_type_string:
		val->string = node->v.string;
		break;
		
	case node_type_symbol:
		val->string = env->getsym(env->data, node->v.string);
		if (!val->string) {
			mu_error("Symbol `%s' is not defined", node->v.string);
			env->status = SMFIS_TEMPFAIL;
			longjmp(env->x, 1);
		}
		break;
		
	case node_type_if:
		eval_node(node->v.cond.cond, env, &vtmp);
		if (vtmp.bool) {
			trace("%s:%lu: MATCHED CONDITION",
			      node->locus.file, node->locus.line);
			eval_node_list(node->v.cond.if_true, env);
		} else
			eval_node_list(node->v.cond.if_false, env);
		break;
		
	case node_type_poll:
		eval_poll(node, env);
		break;
		
	case node_type_bin:
		eval_node(node->v.bin.arg[0], env, &vtmp);
		switch (node->v.bin.opcode) {
		case bin_and:
			if (!vtmp.bool) {
				val->bool = vtmp.bool;
				break;
			}
			eval_node(node->v.bin.arg[1], env, val);
			val->bool &= vtmp.bool;
			break;

		case bin_or:
			if (vtmp.bool) {
				val->bool = vtmp.bool;
				break;
			}
			eval_node(node->v.bin.arg[1], env, val);
			val->bool |= vtmp.bool;
			break;
			
		case bin_eq:
			eval_node(node->v.bin.arg[1], env, val);
			val->bool = strcasecmp(vtmp.string, val->string) == 0;
			break;

		case bin_ne:
			eval_node(node->v.bin.arg[1], env, val);
			val->bool = strcasecmp(vtmp.string, val->string) != 0;
			break;

		case bin_regex:
			val->bool = regexec(&node->v.re.regex, vtmp.string, 0, NULL, 0) == 0;
			break;
			
		case bin_match:
		{
			int rc;
			regex_t re;
			
			eval_node(node->v.bin.arg[1], env, val);
			rc = regcomp(&re, val->string, regex_flags);
			if (rc) {
				char errbuf[512];
				regerror(rc, &re, errbuf, sizeof(errbuf));
				mu_error("runtime error at %s:%lu, compiling regex `%s': %s",
					 val->string,
					 node->locus.file, node->locus.line,
					 errbuf);
				env->status = SMFIS_TEMPFAIL;
				longjmp(env->x, 1);
			}
			val->bool = regexec(&re, vtmp.string, 0, NULL, 0) == 0;
			regfree(&re);
			break;
		}

		case bin_fnmatch:
			eval_node(node->v.bin.arg[1], env, val);
			val->bool = fnmatch (val->string, vtmp.string, 0) == 0;
			break;
		}
		break;
		
	case node_type_un:
		eval_node(node->v.un.arg, env, val);
		val->bool = !val->bool;
		break;

	case node_type_next:
		trace("%s:%lu: next",
		      node->locus.file, node->locus.line);
		break;
		
	case node_type_return:
		trace("%s:%lu: %s %s %s %s",
		      node->locus.file, node->locus.line,
		      sfsistat_str(node->v.ret.stat),
		      node->v.ret.code ? node->v.ret.code : "",
		      node->v.ret.xcode ? node->v.ret.xcode : "",
		      node->v.ret.message ? node->v.ret.message : "");
		env->setreply(env->data,
			      node->v.ret.code,
			      node->v.ret.xcode,
			      node->v.ret.message);
		env->status = node->v.ret.stat;
		longjmp(env->x, 1);
		break;
		
	case node_type_header:
		trace("%s:%lu: %s %s %s",
		      node->locus.file, node->locus.line,
		      header_command_str(node->v.hdr.opcode),
		      node->v.hdr.name,
		      node->v.hdr.value);
		env->setheader(env->data, &node->v.hdr);
		break;

	case node_type_hostname:
		eval_node(node->v.node, env, val);
		eval_hostname(env, val);
		break;

	case node_type_relayed_domain:
		eval_node(node->v.node, env, val);
		val->bool = relayed_domain_p(val->string);
		break;

	case node_type_rate:
		eval_node(node->v.rate.email, env, &vtmp);
		eval_rate(node, env, &vtmp, node->v.rate.limit, val);
		break;

	case node_type_listens:
		eval_node(node->v.node, env, &vtmp);
		val->bool = listens_on (vtmp.string, 25) == mf_success;
		break;
		
	default:
		abort();
	}		
}

void
eval_node_list(NODE *node, struct eval_environ *env)
{
	union value v;
/*	trace("%s:%lu: CONTINUING", node->locus.file, node->locus.line);*/
	for (; node; node = node->next)
		eval_node(node, env, &v);
}


/* Run-time execution */
static char *
ctx_getsym(void *data, char *str)
{
	return smfi_getsymval(data, str);
}

static int
ctx_setreply(void *data, char *code, char *xcode, char *message)
{
	if (code)
		return smfi_setreply(data, code, xcode, message);
	return 0;
}

static void
ctx_setheader(void *data, struct header_node *hdr)
{
	priv_store_header_command(data, hdr);
}

sfsistat
run_program(SMFICTX *ctx)
{
	struct eval_environ env;

	env.data = env.ctx = ctx;
	env.getsym = ctx_getsym;
	env.setreply = ctx_setreply;
	env.setheader = ctx_setheader;
	env.status = SMFIS_CONTINUE;
	dict_init(&env.dict);
	
	if (setjmp(env.x) == 0)
		eval_node_list(root_node, &env);
	dict_destroy(&env.dict);
	return env.status;
}


/* Test run */
struct sfsistat_tab {
	char *name;
	sfsistat stat;
} sfsistat_tab[] = {
	{ "accept", SMFIS_ACCEPT },
	{ "continue", SMFIS_CONTINUE },
	{ "discard", SMFIS_DISCARD },
	{ "reject", SMFIS_REJECT },
	{ "tempfail", SMFIS_TEMPFAIL },
	NULL
};

const char *
sfsistat_str(sfsistat stat)
{
	struct sfsistat_tab *p;
	for (p = sfsistat_tab; p->name; p++)
		if (p->stat == stat) 
			return p->name;
	return NULL;
}

void
print_stat(sfsistat stat)
{
	struct sfsistat_tab *p;
	for (p = sfsistat_tab; p->name; p++)
		if (p->stat == stat) {
			printf("%s", p->name);
			return;
		}
	printf("%d", stat);
}

const char *
header_command_str(enum header_opcode opcode)
{
	switch (opcode) {
	case header_add:
		return "ADD HEADER ";
		
	case header_replace:
		return "REPLACE HEADER ";
		break;

	case header_delete:
		return "DELETE HEADER ";
		break;
	}
	return "UNKNOWN HEADER COMMAND ";
}

static int
dbg_setreply(void *data, char *code, char *xcode, char *message)
{
	if (!code)
		return 0;
	printf("SET REPLY %s", code);
	if (xcode)
		printf(" %s", xcode);
	if (message)
		printf(" %s", message);
	printf("\n");
}

static void
dbg_setheader(void *data, struct header_node *hdr)
{
	printf("SET HEADER %s: %s\n", hdr->name, hdr->value);
}

sfsistat
test_program(list_t dict)
{
	struct eval_environ env;

	env.data = dict;
	env.ctx = NULL;
	env.getsym = dict_getsym;
	env.setreply = dbg_setreply;
	env.setheader = dbg_setheader;
	env.status = SMFIS_CONTINUE;
	dict_init(&env.dict);
	
	if (setjmp(env.x) == 0)
		eval_node_list(root_node, &env);
	dict_destroy(&env.dict);
	
	print_stat(env.status);
	printf("\n");
	
	return env.status;
}

void
set_poll_arg(struct poll_node *poll, int kw, NODE *var)
{
	switch (kw) {
	case FOR:
		poll->email = var;
		break;
		
	case HOST:
		poll->client_addr = var;
		break;
		
	case AS:
		poll->mailfrom = var;
		break;
		
	case FROM:
		poll->ehlo = var;
		break;
		
	default:
		abort();
	}
}
		
static int
time_multiplier(const char *str, unsigned *m, unsigned *plen)
{
	static struct timetab {
		char *name;
		unsigned mul;
	} tab[] = {
		{ "seconds", 1 },
		{ "minutes", 60 },
		{ "hours", 60*60 },
		{ "days",  24*60*60 },
		{ "weeks", 7*24*60*60 },
		{ "months", 31*7*24*60*60 },
		NULL
	};
	struct timetab *p;

	for (p = tab; p->name; p++) {
		if (p->name[0] == tolower(str[0])) {
			int nlen = strlen(p->name);
			int slen = strlen(str);

			if (slen > nlen)
				continue;
			
			if (strncasecmp(p->name, str, slen) == 0) {
				*m = p->mul;
				if (plen)
					*plen = slen;
				return 0;
			}
		}
	}
	return 1;
}

int
convert_rate(const char *arg, double *rate)
{
	double count;
	char *p;

	count = strtod(arg, &p);
	if (*p) {
		char *q;
		double div;

		while (*p && isspace(*p))
			p++;
		switch (*p) {
		case 0:
			break;
		case '/':
			div = 0;
			p++;
			while (*p) {
				unsigned n;
				unsigned m, len;

				while (*p && isspace(*p))
					p++;
				if (isdigit(*p))
					n = strtoul(p, &q, 10);
				else {
					n = 1;
					q = p;
				}
				while (*q && isspace(*q))
					q++;
				if (time_multiplier(q, &m, &len)) {
					mu_error("Invalid interval (near `%s')", q);
					return 1;
				}
				div += n*m;
				p = q + len;
			}
			break;
		default:
			mu_error("Invalid interval (near `%s')", p);
			return 1;
		}

		count /= div;
	}
	*rate = count;
	return 0;
}
		

